<template>
  <b-modal id="modal-xl"
        size="xl"
        ignore-enforce-focus-selector=".ck"
        scrollable visible
        @hidden="cancel" @ok="ok">
    <template #modal-title >
        {{layer.title}} &nbsp;<b-badge variant="secondary"
        style="font-weight: 400;">{{layer.type}}</b-badge>
    </template>
    <div class="layer-infos h-100" style="display: flex;
  flex-flow: column;">
      <b-alert v-if="showTranformWFSMsg" show  variant="warning"
      dismissible>Cette couche est aussi disponible en Vecteur (WFS).
      <b-button  size="sm" variant="outline-secondary" @click="toWFS()">
        Passer en Vecteur
      </b-button> </b-alert>
      <b-alert v-if="showTranformWMSMsg" show variant="warning"
      dismissible>Cette couche est aussi disponible en Raster (WMS).
       <b-button  size="sm" variant="success" @click="toWMS()">
        Passer en Raster
      </b-button> </b-alert>

      <b-tabs  v-model="activeTab" justified
        style="flex:1; min-height: 0;"><!-- use remaining size in height-->
        <SingleLayerMainInfos :layer="layer"/>
        <SingleLayerAttributeInfos :layer="layer"/>
        <SingleLayerPopupInfos :layer="layer"/>
        <SingleLayerStyle v-if="layer.isStylable()" :layer="layer"/>
        <SingleLayerComplexStyle v-if="layer.isStylable() && isComplexStyleEnabled()" :layer="layer"/>
        <DatavizInfos v-if="isDatavizEnabled()" :layer="layer"/>
      </b-tabs>
      <b-alert v-if="errorTxt !== null" show variant="warning" dismissible>{{errorTxt}}</b-alert>
    </div>
    <template #modal-footer>
      <b-container fluid align-v="center" class="mb-2 button-bottom">
        <b-row>
          <b-col class="text-center" cols="12">
            <b-button size="sm" @click="cancel()" style="margin:5px"
            variant="danger">Annuler</b-button>
            <b-button size="sm" @click="ok()" style="margin:5px"
            variant="success">Valider</b-button>
            <b-button size="sm" @click="updateStyle()" style="margin:5px"
            v-if="activeTab==3 || activeTab==4">Appliquer le style</b-button>
            <b-button size="sm" @click="exportSld()" style="margin:5px"
            v-if="activeTab==3 || activeTab==4"><b-icon icon="cloud-download"
            variant="light"></b-icon>&nbsp;Exporter en sld</b-button>
          </b-col>
        </b-row>
      </b-container>
    </template>
  </b-modal>
</template>

<script lang="ts">
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import FormTextInput from '@/components/shared/FormTextInput.vue';
import LayerConfig from '@/models/map-context/LayerConfig';
import FileSaver from 'file-saver';
import Component from 'vue-class-component';
import SingleLayerMainInfos from '@/components/layers/single-layer-infos/SingleLayerMainInfos.vue';
import SingleLayerAttributeInfos from '@/components/layers/single-layer-infos/SingleLayerAttributesInfos.vue';
import SingleLayerPopupInfos from '@/components/layers/single-layer-infos/SingleLayerPopupInfos.vue';
import SingleLayerStyle from '@/components/layers/single-layer-infos/SingleLayerStyle.vue';
import BaseComponent from '../BaseComponent';
import DatavizInfos from './single-layer-infos/DatavizInfos.vue';
import SingleLayerComplexStyle from './single-layer-infos/SingleLayerComplexStyle.vue';

@Component({
  props: {
    layer: LayerConfig,
  },
  components: {
    FormTextInput,
    SingleLayerMainInfos,
    SingleLayerAttributeInfos,
    SingleLayerPopupInfos,
    SingleLayerStyle,
    SingleLayerComplexStyle,
    DatavizInfos,
  },
})
export default class SingleLayerInfos extends BaseComponent {
  layer!: LayerConfig;

  activeTab=0;

  errorTxt:any=null;

  layerBackup!: LayerConfig;

  showTranformWFSMsg=false;

  showTranformWMSMsg=false;

  mounted():void {
    // copie en cas d'annulation des modifications
    // this.layerBackup = JSON.parse(JSON.stringify(this.layer));
    if (this.layer.isWMS() && this.layer.hasWFSCapacity()) {
      this.showTranformWFSMsg = true;
    }
    if (this.layer.isWFS()) {
      this.showTranformWMSMsg = true;
    }
  }

  isDatavizEnabled():boolean {
    return this.contextService.isDatavizEnabled();
  }

  isComplexStyleEnabled():boolean {
    return this.contextService.isComplexStyleEnabled();
  }

  updateLayer() {
    this.layer.error = '';
    const retour = this.getMapService().updateLayer(this.layer);
    if (!retour.success) {
      this.errorTxt = retour.message;
    } else {
      this.contextService.setCurrentAction('', []);
    }
  }

  exportSld() :void{
    const sld = this.layer.styletoSld();
    const filename = `${this.layer.layername}.sld`;
    const blob = new Blob([sld], { type: 'text/xml;charset=utf-8;' });
    if (navigator.msSaveBlob) {
      navigator.msSaveBlob(blob, filename);
    } else {
      FileSaver.saveAs(blob, filename);
    }
  }

  updateStyle() :void{
    this.layer.updateStyle();
  }

  ok() :void{
    this.updateLayer();
  }

  toWFS():void{
    this.getMapService().removeLayerFromMap(this.layer);
    this.layer.type = 'WFS';
    this.layer.url = this.layer.wmsUrlToWfs(this.layer.url);
    this.getMapService().addLayer(this.layer);
    this.showTranformWFSMsg = false;
  }

  toWMS():void{
    this.getMapService().removeLayerFromMap(this.layer);
    this.layer.type = 'WMS';
    const serviceRegex = new RegExp('service(=|%3D)wfs', 'ig');
    const versionRegex = new RegExp('version(=|%3D)2.0.0', 'ig');
    const wfsRegex = new RegExp('wfs', 'ig');
    this.layer.url = this.layer.url.replace(serviceRegex, 'service=wms').replace(versionRegex, 'version=1.3.0').replace(wfsRegex, 'wms');
    this.getMapService().addLayer(this.layer);
    this.showTranformWMSMsg = false;
  }

  cancel() :void{
    console.log('cancel');
    // this.layer = Object.assign(this.layer, this.layerBackup);
    this.contextService.setCurrentAction('', []);
  }
}
</script>

<style scoped lang="less">
.modal-footer{
  justify-content: center;
}
</style>
